#AutoIt3Wrapper_UseX64=n
#include "Bass.au3"
#include "BassExt.au3"
#include <GDIPlus.au3>
#include "GDIP.au3"

Global $iWidth = 480
Global $iHeight = 480
Global $fTransform = 0.05

Opt("GUIOnEventMode", 1)

$sFile = FileOpenDialog("Open...", "", "playable formats (*.MP3;*.MP2;*.MP1;*.OGG;*.WAV;*.AIFF;*.AIF)")
___Debug($sFile = "", $sFile)

$hGui = GUICreate("Stereo Waveform", $iWidth, $iHeight)
GUISetOnEvent(-3, "_EXIT")
GUISetState()

_GDIPlus_Startup()
$hGraphics = _GDIPlus_GraphicsCreateFromHWND($hGui)
$hBmpBuffer = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
$hGfxBuffer = _GDIPlus_ImageGetGraphicsContext($hBmpBuffer)
_GDIPlus_GraphicsSetSmoothingMode($hGfxBuffer, 2)
$hPenL = _GDIPlus_PenCreate(0xFF00FF00, 2)
$hPenR = _GDIPlus_PenCreate(0xFFFF0000, 2)
$hBrushTrans = _GDIPlus_BrushCreateSolid(0x15000000)
$hBmpScale = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
$hGfxScale = _GDIPlus_ImageGetGraphicsContext($hBmpScale)
_GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)

_GDIPlus_GraphicsTranslateTransform($hGfxScale, -($iWidth / 2 * $fTransform), -($iHeight / 2 * $fTransform))
_GDIPlus_GraphicsScaleTransform($hGfxScale, 1 + $fTransform, 1 + $fTransform)
_GDIPlus_GraphicsSetInterpolationMode($hGfxScale, 0)

_BASS_Startup(@ScriptDir & "\bass.dll")
___Debug(@error, "load bass.dll")

_BASS_EXT_Startup(@ScriptDir & "\bassExt.dll")
___Debug(@error, "load bassext.dll")

_BASS_Init(0, -1, 44100, 0, "")
___Debug(@error, "initialize bass")

$hStream = _BASS_StreamCreateFile(False, $sFile, 0, 0, $BASS_SAMPLE_FLOAT)
___Debug(@error, "create stream from file")

_BASS_ChannelPlay($hStream, True)
___Debug(@error, "Start playing stream")

GUIRegisterMsg(0x000F, "WM_PAINT")
GUIRegisterMsg(0x0014, "WM_ERASEBKGND")

$iTimer = TimerInit()
While _BASS_ChannelIsActive($hStream)
	If TimerDiff($iTimer) > 25 Then
		$iTimer = TimerInit()
		_GDIPlus_GraphicsDrawImage($hGfxBuffer, $hBmpScale, 0, 0)

		$aWave = _BASS_EXT_ChannelGetWaveformEx($hStream, 512, 0, $iHeight * 0.42, $iWidth, $iHeight * 0.1, 0, $iHeight * 0.58, $iWidth, $iHeight * 0.1)

		DllCall($ghGDIPDll, "int", "GdipDrawCurve", "handle", $hGfxBuffer, "handle", $hPenL, "ptr", $aWave[0], "int", $aWave[2])
		DllCall($ghGDIPDll, "int", "GdipDrawCurve", "handle", $hGfxBuffer, "handle", $hPenR, "ptr", $aWave[1], "int", $aWave[2])

		_GDIPlus_GraphicsDrawImage($hGfxScale, $hBmpBuffer, 0, 0)
		_GDIPlus_GraphicsFillRect($hGfxScale, 0, 0, $iWidth, $iHeight, $hBrushTrans)
		_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	EndIf
WEnd

_Exit()


Func _Exit()
	_BASS_StreamFree($hStream)
	___Debug(@error, "free stream")

	_BASS_Free()
	___Debug(@error, "free bass")

	_GDIPlus_BrushDispose($hBrushTrans)
	_GDIPlus_GraphicsDispose($hGfxScale)
	_GDIPlus_BitmapDispose($hBmpScale)
	_GDIPlus_PenDispose($hPenL)
	_GDIPlus_PenDispose($hPenR)
	_GDIPlus_GraphicsDispose($hGfxBuffer)
	_GDIPlus_BitmapDispose($hBmpBuffer)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_Exit

Func WM_PAINT($hWnd, $uMsgm, $wParam, $lParam)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	Return 'GUI_RUNDEFMSG'
EndFunc   ;==>WM_PAINT

Func WM_ERASEBKGND($hWnd, $uMsgm, $wParam, $lParam)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	Return True
EndFunc   ;==>WM_ERASEBKGND


Func ___DeBug($iError, $sAction)
	Switch $iError
		Case -1
			ConsoleWrite(@CRLF & "-" & $sAction & @CRLF)
		Case 0
			ConsoleWrite(@CRLF & "+" & $sAction & " - OK" & @CRLF)
		Case Else
			ConsoleWrite(@CRLF & "!" & $sAction & " - FAILED" & @CRLF)
			Exit
	EndSwitch
EndFunc   ;==>___DeBug